//
// Created by robin on 1/8/18.
//

#ifndef QDNSAGG_QDNSPACKET_H
#define QDNSAGG_QDNSPACKET_H

#include <QByteArray>
#include "QDnsHeader.h"
#include "QDnsQuery.h"
#include "QDnsResourceRecord.h"

namespace QDns
{
    namespace Base
    {
        class QDnsPacket
        {
        public:
            QDnsPacket();

            explicit QDnsPacket(const QByteArray &data);

            QDnsPacket(const QByteArray &data, QDataStream &dataStream);

            virtual ~QDnsPacket() = default;

            QByteArray serialize() const;

            void serialize(QDataStream &dataStream) const;

            bool isValid() const;

            QDnsPacket makeAnswer() const;

            const QDnsHeader &getHeader() const;

            void setHeader(const QDnsHeader &header);

            const QList<QDnsQuery> &getQueries() const;

            void setQueries(const QList<QDnsQuery> &queries);

            const QList<QDnsResourceRecord> &getAnswerRecords() const;

            void setAnswerRecords(const QList<QDnsResourceRecord> &answerRecords);

            const QList<QDnsResourceRecord> &getAuthorityRecords() const;

            void setAuthorityRecords(const QList<QDnsResourceRecord> &authorityRecords);

            const QList<QDnsResourceRecord> &getAdditionalRecords() const;

            void setAdditionalRecords(const QList<QDnsResourceRecord> &additionalRecords);

            static QDnsPacket makeSimpleQuery(const QString& host, QDnsBase::RecordType type);

        private:
            void parse(const QByteArray &data, QDataStream &dataStream);

            bool m_isValid;
            QDnsHeader m_header;
            QList<QDnsQuery> m_queries;
            QList<QDnsResourceRecord> m_answerRecords;
            QList<QDnsResourceRecord> m_authorityRecords;
            QList<QDnsResourceRecord> m_additionalRecords;
        };
    }
}

#endif //QDNSAGG_QDNSPACKET_H
