//
// Created by robin on 2/2/18.
//

#ifndef QDNSAGG_QDNSUDPCLIENT_H
#define QDNSAGG_QDNSUDPCLIENT_H

#include <QtNetwork/QUdpSocket>
#include "QDnsClient.h"

namespace QDns
{
    namespace Client
    {
        class QDnsUdpClient : public QDnsClient
        {
            Q_OBJECT
        public:
            explicit QDnsUdpClient(const QHostAddress& host, quint16 port = 53, QObject* parent = nullptr);

        public slots:
            void connectToHost() override;
            void disconnectFromHost() override;

        protected:
            void doQuery(QDns::Base::QDnsPacket packet) override;

        private slots:
            void onReadyRead();
            void onSocketError(QAbstractSocket::SocketError error);

        private:
            QUdpSocket* m_socket;
        };
    }
}

#endif //QDNSAGG_QDNSUDPCLIENT_H
